// HttpFilter.h : Declaration of the CHttpFilter

#ifndef __HTTPFILTER_H_
#define __HTTPFILTER_H_

#include "resource.h"       // main symbols
#include <urlmon.h>
#include <wininet.h>
#include <atlconv.h>
#include <atlbase.h>

/////////////////////////////////////////////////////////////////////////////
// CHttpFilter
class ATL_NO_VTABLE CHttpFilter : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CHttpFilter, &CLSID_HttpFilter>,
	public IInternetProtocol
{
public:
	CHttpFilter() : m_hHttpSession (0), m_hInternetSession (0)
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_HTTPFILTER)
DECLARE_NOT_AGGREGATABLE(CHttpFilter)

DECLARE_PROTECT_FINAL_CONSTRUCT()

// For the two interfaces, expose our class

BEGIN_COM_MAP(CHttpFilter)
	COM_INTERFACE_ENTRY_IID (IID_IInternetProtocolRoot, CHttpFilter)
	COM_INTERFACE_ENTRY_IID (IID_IInternetProtocol    , CHttpFilter)
END_COM_MAP()

public:
	// IInternetProtocolRoot

	HRESULT STDMETHODCALLTYPE Start( 
        /* [in] */ LPCWSTR szUrl,
        /* [in] */ IInternetProtocolSink __RPC_FAR *pOIProtSink,
        /* [in] */ IInternetBindInfo __RPC_FAR *pOIBindInfo,
        /* [in] */ DWORD grfPI,
        /* [in] */ DWORD dwReserved);
    
    HRESULT STDMETHODCALLTYPE Continue( 
        /* [in] */ PROTOCOLDATA __RPC_FAR *pProtocolData);
    
    HRESULT STDMETHODCALLTYPE Abort( 
        /* [in] */ HRESULT hrReason,
        /* [in] */ DWORD dwOptions);
    
    HRESULT STDMETHODCALLTYPE Terminate( 
        /* [in] */ DWORD dwOptions);
    
	HRESULT STDMETHODCALLTYPE Suspend( void) {return E_NOTIMPL;}		// Not implemented

    HRESULT STDMETHODCALLTYPE Resume( void) {return E_NOTIMPL;}		// Not implemented

	// IInternetProtocol based on IInternetProtocolRoot

    HRESULT STDMETHODCALLTYPE Read( 
        /* [length_is][size_is][out][in] */ void __RPC_FAR *pv,
        /* [in] */ ULONG cb,
        /* [out] */ ULONG __RPC_FAR *pcbRead);
    
    HRESULT STDMETHODCALLTYPE Seek( 
        /* [in] */ LARGE_INTEGER dlibMove,
        /* [in] */ DWORD dwOrigin,
        /* [out] */ ULARGE_INTEGER __RPC_FAR *plibNewPosition);
    
    HRESULT STDMETHODCALLTYPE LockRequest( 
        /* [in] */ DWORD dwOptions);
    
    HRESULT STDMETHODCALLTYPE UnlockRequest( void);

private:

	CComPtr<IInternetProtocolSink>	m_pProtocolSink;
	CComPtr<IInternetBindInfo>		m_pBindInfo;
	HINTERNET						m_hInternetSession;
	HINTERNET						m_hHttpSession;

	static void __stdcall StatusCallback (HINTERNET, DWORD, DWORD, LPVOID, DWORD);
};

#endif //__HTTPFILTER_H_
